Package org.pushingpixels.flamingo.api.ribbon

# Class JRibbonComponent

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
org.pushingpixels.flamingo.api.common.RichToolTipManager.JTrackableComponent
org.pushingpixels.flamingo.api.ribbon.JRibbonComponent

All Implemented Interfaces:
  `ImageObserver`, `MenuContainer`, `Serializable`

public class JRibbonComponent extends RichToolTipManager.JTrackableComponent
Wrapper around core and 3rd party Swing controls to allow placing them in the `JRibbonBand`.

See Also:
  - Serialized Form

## Nested Class Summary

## Nested classes/interfaces inherited from class javax.swing.JComponent

`JComponent.AccessibleJComponent`

## Nested classes/interfaces inherited from class java.awt.Container

`Container.AccessibleAWTContainer`

## Nested classes/interfaces inherited from class java.awt.Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`uiClassID`
The UI class ID string.

### Fields inherited from class javax.swing.JComponent

`listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

### Fields inherited from class java.awt.Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface java.awt.image.ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

## Constructor Summary

Constructors
Constructor
Description
`JRibbonComponent(JComponent mainComponent)`
Creates a simple wrapper with no icon and no caption.
`JRibbonComponent(ResizableIcon icon, String caption, JComponent mainComponent)`
Creates a wrapper with an icon and a caption.

## Method Summary

Modifier and Type
Method
Description
`String`
`getCaption()`
Returns the caption of this wrapper component.
`RibbonElementPriority`
`getDisplayPriority()`
`HorizontalAlignment`
`getHorizontalAlignment()`
Returns the horizontal alignment for this wrapper component.
`ResizableIcon`
`getIcon()`
Returns the wrapper icon of this wrapper component.
`String`
`getKeyTip()`
Returns the key tip for this wrapper component.
`JComponent`
`getMainComponent()`
Returns the wrapped component of this wrapper component.
`RichTooltip`
`getRichTooltip(MouseEvent mouseEvent)`
`RibbonComponentUI`
`getUI()`
Returns the UI object which implements the Linvalid input: '&F' for this component.
`String`
`getUIClassID()`
`boolean`
`isResizingAware()`
`boolean`
`isSimpleWrapper()`
Returns indication whether this wrapper is simple.
`void`
`setCaption(String caption)`
Sets new value for the caption of this wrapper component.
`void`
`setDisplayPriority(RibbonElementPriority displayPriority)`
`void`
`setHorizontalAlignment(HorizontalAlignment horizontalAlignment)`
Sets the specified parameter to be the horizontal alignment for this wrapper component.
`void`
`setKeyTip(String keyTip)`
Sets the specified string to be the key tip for this wrapper component.
`void`
`setResizingAware(boolean isResizingAware)`
`void`
`setRichTooltip(RichTooltip richTooltip)`
Sets the rich tooltip for this wrapper component.
`void`
`updateUI()`

### Methods inherited from class javax.swing.JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, paramString, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

### Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getAccessibleContext, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### uiClassID

public static final String uiClassID
The UI class ID string.

See Also:
  - Constant Field Values

## Constructor Details

### JRibbonComponent

public JRibbonComponent(JComponent mainComponent)
Creates a simple wrapper with no icon and no caption.

Parameters:
  `mainComponent` - Wrapped component. Can not be `null`.
Throws:
  `IllegalArgumentException` - if `mainComponent` is `null`.

### JRibbonComponent

public JRibbonComponent(ResizableIcon icon, String caption, JComponent mainComponent)
Creates a wrapper with an icon and a caption.

Parameters:
  `icon` - Wrapper icon. Can be `null`.
  `caption` - Wrapper caption. Can not be `null`.
  `mainComponent` - Wrapped component. Can not be `null`.
Throws:
  `IllegalArgumentException` - if `caption` or `mainComponent` is `null`.

## Method Details

### updateUI

public void updateUI()

Overrides:
  `updateUI` in class `JComponent`

### getUIClassID

public String getUIClassID()

Overrides:
  `getUIClassID` in class `JComponent`

### getUI

public RibbonComponentUI getUI()
Returns the UI object which implements the Linvalid input: '&F' for this component.

Overrides:
  `getUI` in class `JComponent`
Returns:
  a `RibbonUI` object
See Also:
  - `JComponent.setUI(javax.swing.plaf.ComponentUI)`

### getIcon

public ResizableIcon getIcon()
Returns the wrapper icon of this wrapper component. Can return `null`.

Returns:
  The wrapper icon of this wrapper component.
See Also:
  - `JRibbonComponent(ResizableIcon, String, JComponent)`

### getCaption

public String getCaption()
Returns the caption of this wrapper component. Can return `null`.

Returns:
  The caption of this wrapper component.
See Also:
  - `JRibbonComponent(ResizableIcon, String, JComponent)`

### setCaption

public void setCaption(String caption)
Sets new value for the caption of this wrapper component.

Parameters:
  `caption` - The new caption.

### getMainComponent

public JComponent getMainComponent()
Returns the wrapped component of this wrapper component. The result is guaranteed to be non `null`.

Returns:
  The wrapped component of this wrapper component.

### isSimpleWrapper

public boolean isSimpleWrapper()
Returns indication whether this wrapper is simple.

Returns:
  `true` if both `getIcon()` and `getCaption()` return `null`, `false` otherwise.

### getKeyTip

public String getKeyTip()
Returns the key tip for this wrapper component.

Returns:
  The key tip for this wrapper component.
See Also:
  - `setKeyTip(String)`

### setKeyTip

public void setKeyTip(String keyTip)
Sets the specified string to be the key tip for this wrapper component. Fires a `keyTip` property change event.

Parameters:
  `keyTip` - The new key tip for this wrapper component.

### getRichTooltip

public RichTooltip getRichTooltip(MouseEvent mouseEvent)

Specified by:
  `getRichTooltip` in class `RichToolTipManager.JTrackableComponent`

### setRichTooltip

public void setRichTooltip(RichTooltip richTooltip)
Sets the rich tooltip for this wrapper component.

Parameters:
  `richTooltip` -
See Also:
  - `getRichTooltip(MouseEvent)`

### getHorizontalAlignment

public HorizontalAlignment getHorizontalAlignment()
Returns the horizontal alignment for this wrapper component.

Returns:
  The horizontal alignment for this wrapper component.
See Also:
  - `setHorizontalAlignment(HorizontalAlignment)`

### setHorizontalAlignment

public void setHorizontalAlignment(HorizontalAlignment horizontalAlignment)
Sets the specified parameter to be the horizontal alignment for this wrapper component.

Parameters:
  `horizontalAlignment` - The new horizontal alignment for this wrapper component.
See Also:
  - `getHorizontalAlignment()`

### getDisplayPriority

public RibbonElementPriority getDisplayPriority()

### setDisplayPriority

public void setDisplayPriority(RibbonElementPriority displayPriority)

### isResizingAware

public boolean isResizingAware()

### setResizingAware

public void setResizingAware(boolean isResizingAware)